using System;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
using System.Text;

namespace ConsoleApplicationFileSystem
{
    class Folder
    {
        private String name;
        private Map<File> files;
        private Map<Folder> folders;

        public Folder(String dirName)
        {
            this.name = dirName;
            this.files = new Map<File>();
            this.folders = new Map<Folder>();
        }

        public File[] GetAllFiles()
        {
            File[] allFiles = new File[this.files.GetAllKeys().Length];

            String[] files = this.files.GetAllKeys();
            for (int i = 0; i < files.Length; i++)
                allFiles[i] = this.files.GetValue(files[i]);

            return (allFiles);
        }

        public Folder[] GetAllSubFolders()
        {
            Folder[] allSubFolders = new Folder[this.folders.GetAllKeys().Length];

            String[] folders = this.folders.GetAllKeys();
            for (int i = 0; i < folders.Length; i++)
                allSubFolders[i] = this.folders.GetValue(folders[i]);

            return (allSubFolders);
        }

        public void AddFile(File file)
        {
            this.files.Insert(file.GetName(), file);
        }

        public Folder CreateEmptySubFolder(String folderName)
        {
            Folder folder = new Folder(folderName);
            this.folders.Insert(folderName, folder);

            return (folder);
        }

        public String GetName()
        {
            return (this.name);
        }

        public override String ToString()
        {
            String str = "";
            String[] files = this.files.GetAllKeys();
            String[] subFolders = this.folders.GetAllKeys();

            str = this.name + " Content:\n";
            for (int i = 0; i < subFolders.Length; i++)
            {
                Folder folder = this.folders.GetValue(subFolders[i]);
                str = str + folder.name + "\t\t" + "Folder" + "\n";
            }

            for (int i = 0; i < files.Length; i++)
            {
                File file = this.files.GetValue(files[i]);
                str = str + file.GetName() + "\t\t" + "File" + "\t" + file.GetSize() + "\n";
            }
            return str;

        }
    }
}
